#!/usr/bin/bash
  debian_password="debian"
  sudo adduser debian
  echo "debian:$debian_password" | sudo chpasswd
  #  java
  mkdir -p /java
  sudo apt-get update -y
  sudo apt-get install openjdk-17-jdk -y
  sudo cp -r /usr/lib/jvm/java-17-openjdk-amd64/* /java

  mkdir -p /gradle
  wget https://services.gradle.org/distributions/gradle-8.7-bin.zip -P /gradle
  sudo apt-get update -y
  sudo apt-get install -y unzip
  sudo apt-get install -y vim
  unzip /gradle/gradle-8.7-bin.zip -d /gradle
  echo "export PATH=$PATH:/gradle/gradle-8.7/bin" >> /etc/profile
  source /etc/profile

  echo "installing git..."
  sudo apt-get install git -y
  sudo chmod 700 /root/.ssh
  sudo touch /root/.ssh/known_hosts
  sudo chmod 700 /root/.ssh/known_hosts
  sudo sh -c "ssh-keyscan git.cardiff.ac.uk >> /root/.ssh/known_hosts"
  sudo chmod 600 /root/.ssh/known_hosts

  echo "creating sportsLeague.key..."
  sudo touch /root/.ssh/sportsLeague.key
sudo bash -c 'cat << EOF > /root/.ssh/sportsLeague.key
-----BEGIN OPENSSH PRIVATE KEY-----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=
-----END OPENSSH PRIVATE KEY-----
EOF'

  sudo chmod 600 /root/.ssh/sportsLeague.key

  sudo sh -c "ssh-agent bash -c 'ssh-add /root/.ssh/sportsLeague.key; git clone -b sunhaoyu --single-branch git@git.cardiff.ac.uk:c24020257/sports-league-application.git /root/sports-league-application'"

#安装依赖工具
sudo apt update
sudo apt install -y ca-certificates curl gnupg
#添加Docker的GPG密钥
sudo install -m 0755 -d /etc/apt/keyrings
curl -fsSL https://download.docker.com/linux/debian/gpg | sudo gpg --dearmor -o /etc/apt/keyrings/docker.gpg
sudo chmod a+r /etc/apt/keyrings/docker.gpg
#添加Docker的APT源
echo \
  "deb [arch=$(dpkg --print-architecture) signed-by=/etc/apt/keyrings/docker.gpg] https://download.docker.com/linux/debian \
  $(. /etc/os-release && echo "$VERSION_CODENAME") stable" | \
  sudo tee /etc/apt/sources.list.d/docker.list > /dev/null
#更新并安装Docker
sudo apt update
sudo apt install -y docker-ce docker-ce-cli containerd.io docker-buildx-plugin docker-compose-plugin
#启动Docker服务并设置开机自启
sudo systemctl enable --now docker

echo "docker version"
sudo docker -v

sudo -i bash -c "cd /root/sports-league-application && gradle build"
#sudo mkdir -p /nginx
#sudo touch /nginx/nginx.conf
#
#
#sudo sh -c 'cat <<EOF > /nginx/nginx.conf
#
#  user www-data;
#  worker_processes auto;
#  pid /run/nginx.pid;
#  error_log /var/log/nginx/error.log;
#  include /etc/nginx/modules-enabled/*.conf;
#
#  events {
#      worker_connections 768;
#      # multi_accept on;
#  }
#
#  http {
#      upstream sportsLeague {
#              server sports_01:8080;
#              server sports_02:8080;
#            }
#      # Basic Settings
#      sendfile on;
#      tcp_nopush on;
#      types_hash_max_size 2048;
#
#      include /etc/nginx/mime.types;
#      default_type application/octet-stream;
#
#      # SSL Settings (if you enable SSL)
#      # ssl_protocols TLSv1 TLSv1.1 TLSv1.2 TLSv1.3; # Dropping SSLv3, ref: POODLE
#      # ssl_prefer_server_ciphers on;
#
#
#      access_log /var/log/nginx/access.log;
#
#      gzip on;
#
#
#      # Server
#      server {
#          listen 80;
#          server_name _;
#
#          location / {
#              proxy_pass http://sportsLeague;
#          }
#
#          error_page   500 502 503 504  /50x.html;
#          location = /50x.html {
#              root   /usr/share/nginx/html;
#          }
#      }
#
#      include /etc/nginx/conf.d/*.conf;
#      include /etc/nginx/sites-enabled/*;
#  }
#EOF'

#挂载sql
mkdir -p /root/sports/mariadb/init

cp /root/sports-league-application/src/main/resources/sports.sql /root/sports/mariadb/init/

#执行docker-compose
sudo docker compose -f /root/sports-league-application/Docker/docker-compose.yml up -d
#sudo sh -c "mysql -uroot -pcomsc</root/sports-league-application/src/main/resources/sports.sql"




