package uk.ac.cf.spring.demo.sports.images;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;
@Repository
public class ImageRepository {
    private final JdbcTemplate jdbcTemplate;

    @Autowired
    public ImageRepository(JdbcTemplate jdbcTemplate) {
        this.jdbcTemplate = jdbcTemplate;
    }


    public int save(String url) {
        String sql = "INSERT INTO images (url) VALUES (?)";
        return jdbcTemplate.update(sql, url);
    }
    // 获取所有图片记录
    public List<Image> findAll() {
        String sql = "SELECT * FROM images";
        return jdbcTemplate.query(sql, new ImageRowMapper());
    }
    //映射方法
    private static class ImageRowMapper implements RowMapper<Image> {
        @Override
        public Image mapRow(ResultSet rs, int rowNum) throws SQLException {
            Image image = new Image();
            image.setId(rs.getInt("id"));
            image.setUrl(rs.getString("url"));
            image.setUploadedAt(rs.getTimestamp("uploaded_at"));
            return image;
        }
    }

}
