package uk.ac.cf.spring.demo.sports.match;

import jakarta.validation.constraints.Max;
import jakarta.validation.constraints.Min;
import jakarta.validation.constraints.NotEmpty;
import lombok.AllArgsConstructor;
import lombok.Data;

import java.time.LocalDateTime;

@Data
@AllArgsConstructor
public class MatchItem {
    //    match id
    private Long id;

    //    sport type
    @NotEmpty(message = "sport must be selected")
    private String sport;
    //    playerA id
    @Min(value = 0, message = "playerAId must be greater than or equal to 0")
    @Max(value = 60, message = "playerAId must be less than or equal to 1000")
    private Long playerAId;
    //    playerB id
    @Min(value = 0, message = "playerBId must be greater than or equal to 0")
    @Max(value = 60, message = "playerBId must be less than or equal to 1000")
    private Long playerBId;
    //    Time
    private LocalDateTime PlanTime;
    //    pending confirmed completed
    @NotEmpty(message = "Status must be selected")
    private String  status;
    //
    @Min(value = 0, message = "Score A must be greater than or equal to 0")
    @Max(value = 1000, message = "Score A must be less than or equal to 1000")
    private Long scoreA;
    //
    @Min(value = 0, message = "Score B must be greater than or equal to 0")
    @Max(value = 1000, message = "Score B must be less than or equal to 1000")
    private Long scoreB;
    //confirm A
    private Boolean confirmByA;
    // confirm B
    private Boolean confirmByB;
    // winnerId
    private Long winnerId;
    // set Normal data
    public MatchItem() {this(0L,"pools",0L,0L,LocalDateTime.now(),"pending",0L,0L,false,false,0L );}
}
