package uk.ac.cf.spring.demo.sports.rankingtable;

import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/rankings") // 公共路径
public class RankingController {
    private final RankingService rankingService;

    public RankingController(RankingService rankingService) {
        this.rankingService = rankingService;
    }

    /**
     * get all rankings
     *
     * @return all rankings
     */
    @GetMapping
    public List<RankingTable> getAllRankings() {
        return rankingService.getAllRankings();
    }
    @GetMapping("/byallandsort")
    public List<TotalWinsDTO> getRankingsByAllSort(String order) {
        //rankingService.processCompletedMatches();
        return rankingService.getTotalWinsByAll(order);

    }

    /**
     * get rankings filtered by sports and wins
     *
     * @return rankings
     */
    @GetMapping("/bysportandsort")
    public List<RankingTable> getRankingsBySportAndOrder(
            @RequestParam(required = false) String sport,
            @RequestParam(defaultValue = "desc") String order
    ) {
        //rankingService.processCompletedMatches();
        return rankingService.getRankingsBySportAndOrder(sport, order);
    }
    @PostMapping("/updatedata")
    public void updateRankings() {
        rankingService.processCompletedMatches();

    }



}
