package uk.ac.cf.spring.demo.user.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import uk.ac.cf.spring.demo.user.User;
import uk.ac.cf.spring.demo.user.UserRepository;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;

//@RestController
@Controller
//@RequestMapping("/api/users")
public class RegistrationController {

    @Autowired
    private UserRepository userRepository;

    @GetMapping("/register")
    public String showRegistrationForm() {
        return "page/register"; // return register.html
    }


    @PostMapping("/api/users/register")
    public ResponseEntity<?> registerUser(@RequestBody User user) {
        // Check for duplicate usernames or email addresses
        if (userRepository.existsByUsername(user.getUsername())) {
            return ResponseEntity.badRequest().body("{\"message\": \"Username already exists\"}");
        }
        if (userRepository.existsByEmail(user.getEmail())) {
            return ResponseEntity.badRequest().body("{\"message\": \"Email already exists\"}");
        }

        // Save user information to the database
        userRepository.save(user);

        return ResponseEntity.ok("{\"message\": \"Registration successful\"}");
    }
}

