CREATE DATABASE IF NOT EXISTS sports;
USE sports;
drop table if exists match_item;
drop table if exists ranking;
drop table if exists information;
drop table if exists images;
CREATE TABLE information (
                             id INT AUTO_INCREMENT PRIMARY KEY,
                             username VARCHAR(50) UNIQUE NOT NULL,
                             email VARCHAR(50) UNIQUE NOT NULL,
                             password VARCHAR(255) NOT NULL,
                             role VARCHAR(20) DEFAULT 'USER' NOT NULL
);
create table if not exists match_item (
    -- Match ID
    id BIGINT AUTO_INCREMENT PRIMARY KEY,
    -- Sport type
    sport ENUM('Pools', 'Darts', 'TableTennis') NOT NULL,
    -- Player A ID
    player_AId INT NULL,
    -- Player B ID
    player_BId INT NULL,
    plan_Time DATETIME NOT NULL,
    -- Match status
    status ENUM('pending', 'confirmed', 'completed') DEFAULT 'pending',
    score_a INT DEFAULT 0,
    score_b INT DEFAULT 0,
    confirm_a BOOLEAN DEFAULT FALSE,
    confirm_b BOOLEAN DEFAULT FALSE,
    winner_id BIGINT DEFAULT NULL
#     FOREIGN KEY (player_AId) REFERENCES information(id) ON DELETE CASCADE,
#     FOREIGN KEY (player_BId) REFERENCES information(id) ON DELETE CASCADE
#     FOREIGN KEY (player_AId) REFERENCES information(id) ON DELETE SET NULL,
#     FOREIGN KEY (player_BId) REFERENCES information(id) ON DELETE SET NULL
    );


CREATE TABLE IF NOT EXISTS ranking (
                                       id INT AUTO_INCREMENT PRIMARY KEY,
                                       user_id INT NOT NULL,
                                       sport ENUM('Pools', 'Darts', 'TableTennis') NOT NULL,
                                       wins INT DEFAULT 0,
                                       username VARCHAR(255) DEFAULT NULL,
                                       UNIQUE (user_id, sport) -- 添加唯一约束
);
CREATE TABLE images (
                        id INT AUTO_INCREMENT PRIMARY KEY,
                        url VARCHAR(255) NOT NULL,  -- 图片文件名或路径
                        uploaded_at TIMESTAMP DEFAULT CURRENT_TIMESTAMP-- 上传时间
);
