const MATCHES_API_URL = '/match';
// let matches = []
const playerIds = [1, 2, 3, 4];
window.onload = function() {
    fetchMatchItems();
};
// // get all match items
// async function fetchMatch() {
//     function displayMatch(match) {
//
//     }
//
//     try {
//         const res = await  fetch(MATCHES_API_URL);
//         matches = await res.json();
//         displayMatch(matches);
//     }catch(err){
//         console.error('error fetching match data', err)
//     }
// }
// function displayMatch(matches) {
//     // generate the match in tbody
//     const tableBody = document.querySelector('#matchTable tbody');
//     // Clear previous rows
//     tableBody.innerHTML = '';
//     // all match
//     matches.forEach(match => {
//         const row = document.createElement('tr');
//         row.innerHTML = `
//                     <td>${match.id}</td>
//                     <td>${match.sport}</td>
//                     <td>${match.playerAId}</td>
//                     <td>${match.playerBId}</td>
//                     <td>${match.planTime}</td>
//                     <td>${match.status}</td>
//                     <td>${match.scoreA}</td>
//                     <td>${match.scoreB}</td>
//                     <td>${match.confirmByA}</td>
//                     <td>${match.confirmByB}</td>
//                     <td>${match.winnerId}</td>
//                     <td>
//                         <!-- edit button   -->
//                         <button onclick="editMatch(${match.id})">Edit</button>
//                         <!-- delete  button -->
//                         <button onclick="deleteMatch(${match.id})">Delete</button>
//                     </td>
//                 `;
//         tableBody.appendChild(row);
//     });
// }
function generatePoolsCombinations() {
    const matches = [];
    let currentPlanTime = new Date();
    for (let i = 0; i < playerIds.length; i++) {
        for (let j = i + 1; j < playerIds.length; j++) {
            matches.push({
                sport: "Pools",
                playerAId: playerIds[i],
                playerBId: playerIds[j],
                planTime: currentPlanTime.toISOString(),
                status: "pending",
                score_a: 0,
                score_b: 0,
                confirm_a: false,
                confirm_b: false,
                winner_id: null,
            });
            currentPlanTime.setDate(currentPlanTime.getDate() + 1);
        }
    }
    return matches;
}
function generateDartsCombinations() {
    const matches = [];
    let currentPlanTime = new Date();
    for (let i = 0; i < playerIds.length; i++) {
        for (let j = i + 1; j < playerIds.length; j++) {
            matches.push({
                sport: "Darts",
                playerAId: playerIds[i],
                playerBId: playerIds[j],
                planTime: currentPlanTime.toISOString(),
                status: "pending",
                score_a: 0,
                score_b: 0,
                confirm_a: false,
                confirm_b: false,
                winner_id: null,
            });
            currentPlanTime.setDate(currentPlanTime.getDate() + 1);
        }
    }
    return matches;
}
function generateTableTennisCombinations() {
    const matches = [];
    let currentPlanTime = new Date();
    for (let i = 0; i < playerIds.length; i++) {
        for (let j = i + 1; j < playerIds.length; j++) {
            matches.push({
                sport: "TableTennis",
                playerAId: playerIds[i],
                playerBId: playerIds[j],
                planTime: currentPlanTime.toISOString(),
                status: "pending",
                score_a: 0,
                score_b: 0,
                confirm_a: false,
                confirm_b: false,
                winner_id: null,
            });
            currentPlanTime.setDate(currentPlanTime.getDate() + 1);
        }
    }
    return matches;
}
async function submitMatchesToServer(matches) {
    for (const match of matches) {
        try {
            const res = await fetch(MATCHES_API_URL, {
                method: "POST",
                headers: {
                    "Content-Type": "application/json",
                },
                body: JSON.stringify(match),
            });
            if (!res.ok) {
                throw new Error(`${match.playerAId} vs ${match.playerBId}`);
            }
            console.log(`error2：${match.playerAId} vs ${match.playerBId}`);
        } catch (error) {
            console.error("error1", error);
        }
    }
}
document.getElementById("generatePoolsMatches").addEventListener("click", async () => {
    const matches = generatePoolsCombinations();
    console.log("generate list", matches);
    await submitMatchesToServer(matches);
});
document.getElementById("generateDartsMatches").addEventListener("click", async () => {
    const matches = generateDartsCombinations();
    console.log("generate list", matches);
    await submitMatchesToServer(matches);
});
document.getElementById("generateTableTennisMatches").addEventListener("click", async () => {
    const matches = generateTableTennisCombinations();
    console.log("generate list", matches);
    await submitMatchesToServer(matches);
});
// show all matches
function fetchMatchItems() {
    fetch(MATCHES_API_URL)
        .then(res => res.json())
        .then(data => {
            // console.log(data)
            // generate the match in tbody
            const tableBody = document.querySelector('#matchTable tbody');
            // Clear previous rows
            tableBody.innerHTML = '';
            // all match
            data.forEach(match => {
                const matchItem = document.createElement('tr');
                matchItem.innerHTML = `
                    <td>${match.id}</td>
                    <td>${match.sport}</td>
                    <td>${match.playerAId}</td>
                    <td>${match.playerBId}</td>
                    <td>${match.planTime}</td>
                    <td>${match.status}</td>
                    <td>${match.scoreA}</td>
                    <td>${match.scoreB}</td>
                    <td>${match.confirmByA}</td>
                    <td>${match.confirmByB}</td>
                    <td>${match.winnerId}</td>
                    <td>
                        <!-- edit button   -->
                        <button onclick="editMatch(${match.id})">Edit</button>
                        <!-- delete  button -->
                        <button onclick="deleteMatch(${match.id})">Delete</button>
                    </td>
                `;
                tableBody.appendChild(matchItem);
            });
        })
        .catch(err => console.error('error:', err));
}

// Add a new match
function addMatch() {
    const matchForm = document.getElementById('matchForm');
    // formData object
    const formData = new FormData(matchForm);
    const matchData = {};

    formData.forEach((value, key) => {
        matchData[key] = value;
    });
    fetch(MATCHES_API_URL, {
        method: 'POST',
        // for post must set headers for json
        headers: {
            'Content-Type': 'application/json',
        },
        // json => string
        body: JSON.stringify(matchData),
    })
        .then(res => res.json())
        .then(() => {
            alert('Match added successfully!');
            // refresh form
            fetchMatchItems();
            matchForm.reset();
        })
        .catch(err => console.error('error when add match:', err));
}

// delete a match by id
function deleteMatch(id) {
    fetch(`/match/${id}`, {
        method: 'DELETE',
    })
        .then(res => res.json())
        .then(() => {
            alert('match deleted successfully!');
            fetchMatchItems(); // Refresh match list
        })
        .catch(err => console.error('error when delete match:', err));
}

// edit a match and show it in the same palce as add
function editMatch(id) {
    fetch(`/match/${id}`)
        .then(res => res.json())
        .then(match => {
            document.getElementById('sport').value = match.sport;
            document.getElementById('playerAId').value = match.playerAId;
            document.getElementById('playerBId').value = match.playerBId;
            document.getElementById('planTime').value = match.planTime;
            document.getElementById('status').value = match.status;
            document.getElementById('scoreA').value = match.scoreA;
            document.getElementById('scoreB').value = match.scoreB;
            document.getElementById('confirmByA').checked = match.confirmByA;
            document.getElementById('confirmByB').checked = match.confirmByB;
            document.getElementById('winnerId').value = match.winnerId;
            // change the add button to an update button
            const addButton = document.querySelector('#matchForm button');
            addButton.textContent = 'Update Match';
            //  update an existing match
            addButton.setAttribute('onclick', `updateMatch(${id})`);
        })
        .catch(error => console.error('error when edit match:', error));
}

// update an existing match
function updateMatch(id) {
    const matchForm = document.getElementById('matchForm');
    const formData = new FormData(matchForm);
    const matchData = {};

    formData.forEach((value, key) => {
        matchData[key] = value;
    });

    fetch(`/match/${id}`, {
        method: 'PUT',
        headers: {
            'Content-Type': 'application/json',
        },
        body: JSON.stringify(matchData),
    })
        .then(res => res.json())
        .then(() => {
            alert('match updated successfully!');
            fetchMatchItems();
            matchForm.reset();
            // change the Update button back to Add button
            const addButton = document.querySelector('#matchForm button');
            addButton.textContent = 'Add Match';
            addButton.setAttribute('onclick', 'addMatch()');
        })
        .catch(err => console.error('error update match:', err));
}
